-- Hopefully this works

library ieee;
use ieee.std_logic_1164.all;

entity handshake is
  port (
    clk_src    : in  std_logic;
    clk_dest   : in  std_logic;
    rst        : in  std_logic;
    start_pl   : in  std_logic;
    take_it_pl : out std_logic;
    got_it_pl  : out std_logic
    );
end handshake;

architecture toggle of handshake is
  signal take_it_tg         : std_logic;
  signal take_it_tg_mux     : std_logic;
  signal take_it_reg1       : std_logic;
  signal take_it_reg2       : std_logic;
  signal take_it_reg2_delay : std_logic;
  signal take_it_pl_s       : std_logic;

  signal got_it_tg         : std_logic;
  signal got_it_tg_mux     : std_logic;
  signal got_it_reg1       : std_logic;
  signal got_it_reg2       : std_logic;
  signal got_it_reg2_delay : std_logic;
begin


  ---------------------------------------------------------------------
  -- Source Clock Domain
  ---------------------------------------------------------------------
  take_it_tg_mux <= take_it_tg when start_pl = '0'
                    else (not take_it_tg);
  process(clk_src, rst)
  begin
    if (rst = '1') then
      take_it_tg        <= '0';
      got_it_reg1       <= '0';
      got_it_reg2       <= '0';
      got_it_reg2_delay <= '0';
    elsif (rising_edge(clk_src)) then
      take_it_tg        <= take_it_tg_mux;
      got_it_reg1       <= got_it_tg;
      got_it_reg2       <= got_it_reg1;
      got_it_reg2_delay <= got_it_reg2;
    end if;
  end process;
  got_it_pl <= got_it_reg2 xor got_it_reg2_delay;

  ---------------------------------------------------------------------
  -- Destination Clock Domain
  ---------------------------------------------------------------------
  got_it_tg_mux <= got_it_tg when take_it_pl_s = '0'
                   else (not got_it_tg);
  process(clk_dest, rst)
  begin
    if (rst = '1') then
      got_it_tg          <= '0';
      take_it_reg1       <= '0';
      take_it_reg2       <= '0';
      take_it_reg2_delay <= '0';
    elsif (rising_edge(clk_dest)) then
      got_it_tg          <= got_it_tg_mux;
      take_it_reg1       <= take_it_tg;
      take_it_reg2       <= take_it_reg1;
      take_it_reg2_delay <= take_it_reg2;
    end if;
  end process;
  take_it_pl_s <= take_it_reg2 xor take_it_reg2_delay;
  take_it_pl   <= take_it_pl_s;

end architecture;
