-- Greg Stitt
-- Jayson Salkey
-- Abdelali Nouina
-- David Wilson
-- University of Florida

library ieee;
use ieee.std_logic_1164.all;
package user_pkg is

  subtype addr_type is integer range 0 to 32;

  -- Memory map addresses
  constant C_GO_ADDR   : addr_type := 0;
  constant IN1_ADDR    : addr_type := 1;
  constant IN2_ADDR    : addr_type := 2;
  constant RESULT_ADDR : addr_type := 3;
  constant DONE_ADDR   : addr_type := 4;

  -- Memory map widths
  constant DATA_WIDTH        : positive := 15;
  constant C_MMAP_ADDR_WIDTH : positive := 16;
  constant C_MMAP_DATA_WIDTH : positive := 15;

  -- Memory map ranges
  subtype MMP_INSTR_RANG is natural range 31 downto 0;
  subtype DATA_RANGE is natural range DATA_WIDTH-1 downto 0;
  subtype MMAP_ADDR_RANGE is natural range C_MMAP_ADDR_WIDTH-1 downto 0;
  subtype MMAP_DATA_RANGE is natural range C_MMAP_DATA_WIDTH-1 downto 0;

  -- IR addresses
  constant IR_LENGTH : natural := 3;

  constant C_ADDR_IR    : std_logic_vector(IR_LENGTH-1 downto 0) := "001";
  constant C_RD_DATA_IR : std_logic_vector(IR_LENGTH-1 downto 0) := "010";
  constant C_WR_DATA_IR : std_logic_vector(IR_LENGTH-1 downto 0) := "011";

end user_pkg;
